{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DerivingStrategies #-}
{-# LANGUAGE GeneralizedNewtypeDeriving #-}
{-# LANGUAGE LambdaCase #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE PatternSynonyms #-}
{-# LANGUAGE StrictData #-}
{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.MediaConvert.Types.H265SampleAdaptiveOffsetFilterMode
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.MediaConvert.Types.H265SampleAdaptiveOffsetFilterMode
  ( H265SampleAdaptiveOffsetFilterMode
      ( ..,
        H265SampleAdaptiveOffsetFilterMode_ADAPTIVE,
        H265SampleAdaptiveOffsetFilterMode_DEFAULT,
        H265SampleAdaptiveOffsetFilterMode_OFF
      ),
  )
where

import qualified Amazonka.Core as Core
import qualified Amazonka.Data as Data
import qualified Amazonka.Prelude as Prelude

-- | Specify Sample Adaptive Offset (SAO) filter strength. Adaptive mode
-- dynamically selects best strength based on content
newtype H265SampleAdaptiveOffsetFilterMode = H265SampleAdaptiveOffsetFilterMode'
  { fromH265SampleAdaptiveOffsetFilterMode ::
      Data.Text
  }
  deriving stock
    ( Prelude.Show,
      Prelude.Read,
      Prelude.Eq,
      Prelude.Ord,
      Prelude.Generic
    )
  deriving newtype
    ( Prelude.Hashable,
      Prelude.NFData,
      Data.FromText,
      Data.ToText,
      Data.ToByteString,
      Data.ToLog,
      Data.ToHeader,
      Data.ToQuery,
      Data.FromJSON,
      Data.FromJSONKey,
      Data.ToJSON,
      Data.ToJSONKey,
      Data.FromXML,
      Data.ToXML
    )

pattern H265SampleAdaptiveOffsetFilterMode_ADAPTIVE :: H265SampleAdaptiveOffsetFilterMode
pattern H265SampleAdaptiveOffsetFilterMode_ADAPTIVE = H265SampleAdaptiveOffsetFilterMode' "ADAPTIVE"

pattern H265SampleAdaptiveOffsetFilterMode_DEFAULT :: H265SampleAdaptiveOffsetFilterMode
pattern H265SampleAdaptiveOffsetFilterMode_DEFAULT = H265SampleAdaptiveOffsetFilterMode' "DEFAULT"

pattern H265SampleAdaptiveOffsetFilterMode_OFF :: H265SampleAdaptiveOffsetFilterMode
pattern H265SampleAdaptiveOffsetFilterMode_OFF = H265SampleAdaptiveOffsetFilterMode' "OFF"

{-# COMPLETE
  H265SampleAdaptiveOffsetFilterMode_ADAPTIVE,
  H265SampleAdaptiveOffsetFilterMode_DEFAULT,
  H265SampleAdaptiveOffsetFilterMode_OFF,
  H265SampleAdaptiveOffsetFilterMode'
  #-}
